<%@ Page Language="C#" Inherits="System.Web.UI.Page" %>
<%@ Register TagPrefix="SharePoint" Namespace="Microsoft.SharePoint.WebControls" Assembly="Microsoft.SharePoint, Version=12.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %>
<%@ Import Namespace="Microsoft.SharePoint" %>
<script runat="server">
void Page_Load()
{
    if (Request.Url.ToString().Contains("_BACKSLASH_")) Response.Redirect(Request.Url.ToString().Replace("_BACKSLASH_", "%5C"));
      
    string listID = Page.Request.QueryString["ListID"] != null ? Page.Request.QueryString["ListID"].ToString() : string.Empty;
    string viewID = Page.Request.QueryString["ViewID"] != null ? Page.Request.QueryString["ViewID"].ToString() : string.Empty;
	
	if(listID != string.Empty && viewID != string.Empty)
	{
		try
		{
			SPWeb web = SPContext.Current.Web;
			SPList list = web.Lists[new Guid(listID)];
            SPView currentView = list.Views[new Guid(viewID)];
            string viewTitle = currentView.Title != string.Empty ? " - " + currentView.Title : string.Empty;

            if (currentView.Type.ToUpper().Equals("CALENDAR"))
            {
                string calendarDate = Page.Request.QueryString["CalendarDate"] != null ? Page.Request.QueryString["CalendarDate"].ToString() : string.Empty;
                string calendarPeriod = Page.Request.QueryString["CalendarPeriod"] != null ? Page.Request.QueryString["CalendarPeriod"].ToString() : string.Empty;
                
                SPCalendarDataSource calDS = new SPCalendarDataSource();
                calDS.List = list;
                calDS.View = currentView;
                calendarView.ListName = list.ID.ToString();
                if (calendarPeriod != string.Empty) calendarView.ViewType = calendarPeriod;
                if (calendarDate != string.Empty) calendarView.SelectedDate = calendarDate;
                calendarView.DataSource = calDS;
                calendarView.DataBind();
                calendarView.Visible = true;         
            }
            else
            {
                SPQuery query = new SPQuery(currentView);
                htmlViewLiteral.Text = list.RenderAsHtml(query);
                htmlViewLiteral.Visible = true;          
            }

            printDialogLiteral.Text = "<script type=\"text/javascript\">window.print();<" + "/script>";
            pageTitleLiteral.Text = list.Title + viewTitle;
		}
		catch { }
	}
	else
	{
		Page.Response.Write("Missing ListID and/or ViewURL parameter");
	}
}
</script>

<html>
    <head>
        <title><asp:Literal ID="pageTitleLiteral" runat="server" /></title>
        <link rel="stylesheet" type="text/css" href="/_layouts/1041/styles/core.css" />
        <SharePoint:CssLink ID="CssLink" runat="server"/>
	    <SharePoint:Theme ID="Theme" runat="server"/>
	    <style type="text/css">.ms-cal-monthitem a:link { text-decoration:none !important; }</style>
        <script type="text/javascript" language="javascript" src="/_layouts/1041/init.js"></script>
        <script type="text/javascript" language="javascript" src="/_layouts/1041/core.js"></script>
        <script type="text/javascript" language="javascript" src="/_layouts/1041/ie55up.js"></script>
    </head>
    <body>
        <SharePoint:SPCalendarView ID="calendarView" runat="server" Visible="false" Width="100%" />
        <asp:Literal ID="htmlViewLiteral" runat="server" Visible="false" />
        <asp:Literal ID="printDialogLiteral" runat="server" />
        <div style="display:none">Printer Icon downloaded from www.pixel-mixer.com</div>
    </body>
</html>